#ifndef TARTPARAMETERNEBULA_HH
#define TARTPARAMETERNEBULA_HH

#include "TObject.h"

#include "TArtParameter.hh"

#include <map>

#include "TArtMap.h"
#include "segidlist.h"

class TXMLNode;
class TArtNEBULAPara;
class TArtRIDFMap;

class TArtParameterNEBULA : public TArtParameter
{
 public:
  class TArtParameterNEBULAInner
  {
  private:
    TArtParameterNEBULAInner();//cannot construct by default constructor
  public:
    TArtParameterNEBULAInner(Int_t id, TString detname, Int_t fpl,
			     Int_t layer, Int_t sublayer,
			     Double_t tcal, Double_t toff,
			     Double_t qcal, Double_t qped,
			     Int_t ignore);
    ~TArtParameterNEBULAInner();
    
    void SetMap(Int_t tgeo, Int_t tch, Int_t qgeo, Int_t qch);

    Int_t     fID;
    TString   fDetName;
    Int_t     fFPl;
    Int_t     fLayer;
    Int_t     fSubLayer;
    Double_t  fTCal;
    Double_t  fTOff;
    Double_t  fQCal;
    Double_t  fQPed;
    Int_t     fIgnore;

    TArtRIDFMap fMapTDC;
    TArtRIDFMap fMapADC;
  };

 public:
  TArtParameterNEBULA(char *xmlfile);
  ~TArtParameterNEBULA();

  void ParseParaList(TXMLNode *node);
  const TArtParameterNEBULAInner* Find(const TArtRIDFMap& map);

  //private:  not yet
  std::map<TArtRIDFMap, TArtParameterNEBULAInner> fPMap;

private:
  TArtParameterNEBULAInner ParseNEBULAPara(TXMLNode *node);

  ClassDef(TArtParameterNEBULA,1);
};

#endif
