#ifndef TARTHISTMANAGER_HH
#define TARTHISTMANAGER_HH

class TH1;
class TDirectory;
class TArtObjLinkManager;

//Pointer of current hist.
//This pointer is valid after public method of TArtHistManager has been called,
//except ReadHist, WriteHist, and ShowHist.
extern TH1* gTH1;

class TArtHistManager
{
public:
  //Read all TH1 object in file(filename) to current directory.
  static void ReadHist(char *filename);
  //Write all TH1 object in current directory to file(filename)
  static void WriteHist(char *filename);

  //show list of hist in current directory.
  static void ShowHist();

  //find hist by id
  static TH1* FindHist(int id);

  //draw hist by id
  static void DrawHist(int id);
  static void DrawCurrentHist();
  static void DrawNextHist();
  static void DrawPreviousHist();
  //draw hist and set to gTH1.
  static void DrawHist(TH1* hist);

  //return current hist.
  static TH1* GetHist();
  //set gTH1 to hist.
  static TH1* SetHist(TH1* hist);
  //set gTH1 to 0.
  static void ResetHist();

  static TH1* GetNextHist();
  static TH1* GetPreviousHist();

  static TH1* GetFirstHist();
  static TH1* GetLastHist();

private:
  static TArtObjLinkManager* fArtObjLinkManager;
};

#endif
