#ifndef TARTOBJLINKMANAGER_HH
#define TARTOBJLINKMANAGER_HH

class TList;
class TObject;
class TObjLink;

class TArtObjLinkManager
{
public:
  TArtObjLinkManager();
  ~TArtObjLinkManager();

  //return fObjLink. If no object is in gDirectory, return 0;
  TObjLink* GetObjLink();
  //set fObjLink to objlink.
  TObjLink* SetObjLink(TObjLink* objlink);
  //set fObjLink by TObject
  TObjLink* SetObjLink(TObject* object);
  //set fObjLink to 0;
  void ResetObjLink();

  //if fObjLink is 0, return first objlink
  TObjLink* NextObjLink();
  //if fObjLink is 0, return last objlink
  TObjLink* PreviousObjLink();

  //return first objlink
  TObjLink* FirstObjLink();
  //return last objlink
  TObjLink* LastObjLink();

private:
  //return list of current directory
  TList* GetList();

  //Pointer of current objlink.
  //This pointer is valid after public method has been called.
  TObjLink* fObjLink;
};

#endif
