
#include "TArtObjLinkManager.hh"

#include "TFile.h"
#include "TList.h"

#include <iostream>

TArtObjLinkManager::TArtObjLinkManager()
  : fObjLink(0)
{;}

TArtObjLinkManager::~TArtObjLinkManager()
{;}

TObjLink* TArtObjLinkManager::GetObjLink()
{
  if(!fObjLink){
    return FirstObjLink();
  }else{
    return fObjLink;
  }
}

TObjLink* TArtObjLinkManager::SetObjLink(TObjLink* objlink)
{
  TObjLink* objlink_check;
  TList* list = GetList();
  if(list){
    objlink_check = list->FirstLink();	
  }else{
    objlink_check = 0;
  }

  while(objlink_check){
    if(objlink_check == objlink){
      return fObjLink = objlink_check;
    }else{
      objlink_check = objlink_check->Next();
    }
  }    

  std::cout << "cannot set objlink" << std::endl;
  return 0;
}

TObjLink* TArtObjLinkManager::SetObjLink(TObject* object)
{
  TObjLink* objlink_check;
  TList* list = GetList();
  if(list){
    objlink_check = list->FirstLink();	
  }else{
    objlink_check = 0;
  }

  while(objlink_check){
    if(objlink_check->GetObject()->IsEqual(object)){
      return fObjLink = objlink_check;
    }else{
      objlink_check = objlink_check->Next();
    }
  }    

  std::cout << "cannot set objlink" << std::endl;
  return 0;
}

void TArtObjLinkManager::ResetObjLink()
{
  fObjLink = 0;
}

TObjLink* TArtObjLinkManager::NextObjLink()
{
  if(!fObjLink){
    return FirstObjLink();
  }else{
    TObjLink* objlink = fObjLink->Next();
    if(!objlink) objlink = FirstObjLink();

    fObjLink = objlink;
    return objlink;
  }
}

TObjLink* TArtObjLinkManager::PreviousObjLink()
{
  if(!fObjLink){
    return LastObjLink();
  }else{
    TObjLink* objlink = fObjLink->Prev();
    if(!objlink) objlink = LastObjLink();

    fObjLink = objlink;
    return objlink;
  }
}

TObjLink* TArtObjLinkManager::FirstObjLink()
{
  TObjLink* objlink;
  TList* list = GetList();
  if(list){
    objlink = list->FirstLink();	
  }else{
    objlink = 0;
  }

  fObjLink = objlink;
  return objlink;
}

TObjLink* TArtObjLinkManager::LastObjLink()
{
  TObjLink* objlink;
  TList* list = GetList();
  if(list){
    objlink = list->LastLink();	
  }else{
    objlink = 0;
  }

  fObjLink = objlink;
  return objlink;
}

TList* TArtObjLinkManager::GetList()
{
  TList* list;
  if(gDirectory){
    list = gDirectory->GetList();
  }else{
    list = 0;
  }

  return list;
}
