#ifndef _TARTBIGRIPSPARAMETERS_H_
#define _TARTBIGRIPSPARAMETERS_H_

#include <TROOT.h>
#include <vector>

class TList;
class TXMLNode;
class TArtPPACPara;
class TArtPlasticPara;
class TArtICPara; 
class TArtFocalPlanePara; 
class TArtRIPSPara; 
class TArtTOFPara; 
class TArtBeamPara; 

class TArtBigRIPSParameters : public TNamed
{
 public: 

  TArtBigRIPSParameters();
  ~TArtBigRIPSParameters();

  TList* GetListOfPPACPara()      {return listOfPPACPara;      }
  TList* GetListOfPlasticPara()   {return listOfPlasticPara;   }
  TList* GetListOfICPara()    {return listOfICPara;    }
  TList* GetListOfFocalPlanePara(){return listOfFocalPlanePara;}
  TList* GetListOfRIPSPara(){return listOfRIPSPara;}
  TList* GetListOfTOFPara(){return listOfTOFPara;}
  TList* GetListOfBeamPara(){return listOfBeamPara;}

  Bool_t LoadParameter(char *xmlfile);
  TArtRIPSPara * AddOptMatrix(Int_t ffpl, Int_t bfpl, char *file, Double_t brho);
  TArtTOFPara  * AddTOF(char *fplname, char *bplname, Double_t offset=0);
  TArtBeamPara * AddBeam(TArtRIPSPara* r, TArtTOFPara *t, char *dename);
  TArtBeamPara * AddBeam(TArtRIPSPara* fr, TArtRIPSPara *br, TArtTOFPara *t, char *dename);
  void   SetFocusPosOffset(Int_t fpl, Double_t offset);

  // print all of parameters
  // void Print();

 protected:

  TList *listOfPPACPara;
  TList *listOfPlasticPara;
  TList *listOfICPara;
  TList *listOfFocalPlanePara;
  TList *listOfRIPSPara;
  TList *listOfTOFPara;
  TList *listOfBeamPara;

  void ParseParaList(TXMLNode *node);
  TArtPPACPara * ParsePPACPara(TXMLNode *node);
  TArtPlasticPara * ParsePlasticPara(TXMLNode *node);
  TArtICPara * ParseICPara(TXMLNode *node);
  TArtFocalPlanePara * ParseFocalPlanePara(TXMLNode *node);

  ClassDef(TArtBigRIPSParameters,1);

};

#endif
